/*
 * Endpoint - Linux SBP2 Disk Target
 *
 * Copyright (C) 2003 Oracle.  All rights reserved.
 *
 * Author: Manish Singh <manish.singh@oracle.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 021110-1307, USA.
 */

#ifndef __SBP2_WORKER_H__
#define __SBP2_WORKER_H__


#include <glib.h>

#include <libraw1394/raw1394.h>

#include <librbc/rbcdisk.h>

#include <libsbp2/sbp2pointer.h>
#include <libsbp2/sbp2login.h>


typedef struct _SBP2Worker SBP2Worker;


SBP2Worker *sbp2_worker_new       (RBCDisk      *disk,
                                   GMainContext *context,
				   gint          port,
				   guint         login_ID);

void        sbp2_worker_destroy   (SBP2Worker   *worker);

gboolean    sbp2_worker_login     (SBP2Worker   *worker,
				   nodeid_t      node,
				   SBP2Pointer  *pointer,
				   SBP2LoginORB *orb);

gboolean    sbp2_worker_reconnect (SBP2Worker   *worker,
                                   nodeid_t      node);


#endif /* __SBP2_WORKER_H__ */
